//+------------------------------------------------------------------+
//|                                                     TradeSAR.mq4 |
//-------------------------------------------------------------------+
#define BULL 1
#define BEAR 2
//+------------------------------------------------------------------+
extern int    Slippage   = 5;
extern int    Magic      = 55;
extern double Lots       = 0.1;
extern int    StopLoss   = 0;
extern double SarStep    = 0.02;
extern double SarMaximum = 0.2;
//-------------------------------------------------------------------+
string OrderComments = "TradeSAR";
int Cnt = 0;
datetime PreviousBar;
//-------------------------------------------------------------------+
//-------------------------------------------------------------------+ 
int deinit() {return(0);} 
//-------------------------------------------------------------------+
int start(){
  if(TotalOpenOrders() > 0) CheckForClose();
  if(NewBar() == true){
    if(TrendDetection() == BULL){
      if(StopLoss > 0)
      {OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),Slippage,NormalizeDouble(Ask,Digits)-(StopLoss*Point),0,OrderComments,Magic,0,CLR_NONE);}
      if(StopLoss == 0)
      {OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),Slippage,0,0,OrderComments,Magic,0,CLR_NONE);}}
    if(TrendDetection() == BEAR){
      if(StopLoss > 0)
      {OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),Slippage,NormalizeDouble(Bid,Digits)+(StopLoss*Point),0,OrderComments,Magic,0,CLR_NONE);}
      if(StopLoss == 0)
      {OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),Slippage,0,0,OrderComments,Magic,0,CLR_NONE);}}}
  return(0);}
//-------------------------------------------------------------------+
int TotalOpenOrders(){
  Cnt=OrdersTotal();
  int TotalOpenOrders = 0;
  if(Cnt==0)
  {return(0);}
    else{for(;Cnt>=0;Cnt--)
    {OrderSelect(Cnt,SELECT_BY_POS);if(OrderMagicNumber()==Magic)
      {TotalOpenOrders++;}}}
  return(TotalOpenOrders);}
//-------------------------------------------------------------------+
bool NewBar(){
  if(PreviousBar<Time[0])
  {PreviousBar = Time[0];return(true);}
  else {return(false);}
  return(false);}
//-------------------------------------------------------------------+
void CheckForClose(){
  {for(Cnt = OrdersTotal();Cnt >= 0;Cnt--)
    {OrderSelect(Cnt,SELECT_BY_POS,MODE_TRADES); if(OrderSymbol() == Symbol())
      {if(OrderType() == OP_BUY && OrderMagicNumber()==Magic)
        {if((Close[1] < Open[1] && Close[2] > Open[2] && OrderProfit()>0)||(TrendDetection()==BEAR))
          {OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,CLR_NONE);}}}}}
  {for(Cnt = OrdersTotal();Cnt >= 0;Cnt--)
    {OrderSelect(Cnt,SELECT_BY_POS,MODE_TRADES); if(OrderSymbol() == Symbol())
       {if(OrderType() == OP_SELL && OrderMagicNumber()==Magic)
        {if((Close[1] > Open[1] && Close[2] < Open[2] && OrderProfit()>0)||(TrendDetection()==BULL))
          {OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,CLR_NONE);}}}}}}
//-------------------------------------------------------------------+
int TrendDetection(){
  double Sar = iSAR(NULL,0,SarStep,SarMaximum,1);
  if(Close[1] > Sar) {return(BULL);}
  if(Close[1] < Sar) {return(BEAR);}
  return(0);}
//-------------------------------------------------------------------+